package WebFlow.xml; 
import WebFlow.*; 
import WebFlow.event.*; 
import WebFlow.submitJob.*;
import WebFlow.GatewayTest.*;
import org.omg.CORBA.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import java.net.*; 
import java.util.*;

public class Client0{

public static String XmlInput;
public static String RSL;
public static String InstallRSL;

   public static void main(String args[])
   {
      configReader config ; 
      //      String display="aga.npac.syr.edu:0";
      String display="24.95.171.67:0.0";
      try
      {
         //  Create ORB
         Properties props = System.getProperties();
         props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
         props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
         System.setProperties(props);

         ORB orb = ORB.init(args, props);

         //  Connect to the master server


         if(args.length !=2) {
           System.out.println("Usage:");
           System.out.println("   WebFlow.JobService.Client url xml");
           System.out.println("     url - url to the master's IOR");
           System.out.println("     xml - xml file containg application descriptor");
           System.exit(1);
	 }    

         String masterURL = args[0] ; 

         XmlInput = args[1];
         File xmlfile = new File(XmlInput);
         if(!xmlfile.exists()) {
            System.out.println("file: "+XmlInput+" does not exist");
            System.out.println("Sorry. Quitting...");
            System.exit(1);
	 }
    
         String ref ; 
         org.omg.CORBA.Object obj = null ; 
         System.out.println(" masterURL : "+masterURL); 

         ref = getIORFromURL(masterURL); 

         System.out.println("REF: "+ref); 

         obj = orb.string_to_object(ref); 

         if(obj == null)
              throw new RuntimeException(); 

         WebFlowContext ws =  WebFlowContextHelper.narrow(obj);
         System.out.println("Clinet: got master "+ws);
  
         if(ws == null)
               throw new RuntimeException(); 


         System.out.println("attach GatewayTest------------------------"); 

          org.omg.CORBA.Object p3 = ws.addNewModule("GatewayTest"); 
          if(p3==null) System.out.println("GatewayTest object is null"); 
          else System.out.println(p3);
          WebFlow.GatewayTest.XmlServer gt = WebFlow.GatewayTest.XmlServerHelper.narrow(p3);   
          gt.test();

         System.out.println("attach XmlServer------------------------"); 

          org.omg.CORBA.Object p1 = ws.addNewModule("XmlServer"); 
          WebFlow.xml.XmlServer parser = WebFlow.xml.XmlServerHelper.narrow(p1); 
          parser.test();

         System.out.println("attach submitJob------------------------"); 

          org.omg.CORBA.Object p2 = ws.addNewModule("submitJob");
          submitJob submit = submitJobHelper.narrow(p2);

          submit.test();

          System.out.println("DISPLAY is set to: "+display);
          System.out.println("recompile Client0 to change"); 

         if (parser.instantiateParser(XmlInput)) {
 
         String[] applications = parser.getApplications();
         int n = applications.length;    
         for (int i=0; i<n; i++) {
             System.out.println(applications[i]);
	 }
	 } 

        String command = "xterm -d "+display;
        System.out.println("Execute: "+command);
        submit.submitLocally(command); 
  
        ws.removeModule(p1);
        ws.removeModule(p2); 
        ws.removeModule(p3); 

      } catch(COMM_FAILURE ex) {
        System.out.println("Command_Error: "+ex); 

        System.err.println(ex.getMessage()); 
        ex.printStackTrace(); 
        System.exit(1); 
       }  
   } 

   static public String getIORFromURL(String url) {

   System.out.println("Slave WebFlow is getting IOR from url:"+url); 
   String masterServerIOR =""; 
   String thisLine = null ; 

   // Open the URL for reading 
 
   try{
        URL u = new URL(url); 

        // now turn the URL into a DataInputStream

        try{
         DataInputStream theHTML = new DataInputStream(u.openStream());

          while((thisLine = theHTML.readLine()) != null){ 
             masterServerIOR += thisLine ; 
          } 
        }
        catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
        }
     }
     catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
     }
    return masterServerIOR ; 
  }
}
